# Conversation Message Feedbacks

## Create or update conversation message feedback

> Create or update existing conversation message feedback. The response includes the conversation message feedback.

```json
{"openapi":"3.0.0","info":{"title":"AI Agent API","version":"1.0.0"},"servers":[{"url":"https://api.raia2.com","description":"Production server"}],"security":[{"Agent-Secret-Key":[]}],"components":{"securitySchemes":{"Agent-Secret-Key":{"type":"apiKey","in":"header","name":"Agent-Secret-Key","description":"Custom authentication header"}},"schemas":{"ExternalApiCrateOrUpdateConversationMessageFeedbackBodyDTO":{"type":"object","properties":{"conversationMessageId":{"type":"string","description":"Unique identifier for the conversation message.","format":"uuid"},"userId":{"type":"string","description":"Unique identifier for the user.","format":"uuid"},"voteType":{"type":"string","enum":["up","down"],"description":"Feedback vote type. Up if feedback is positive"},"question":{"type":"string","description":"Your question."},"answer":{"type":"string","description":"Agent answer."},"comment":{"type":"string","description":"Comment for your feedback."}},"required":["conversationMessageId","userId","voteType","question"]},"ExternalApiCrateOrUpdateConversationMessageFeedbackResponseDTO":{"type":"object","properties":{"id":{"type":"string","description":"Unique identifier for the conversation message feedback.","format":"uuid"},"conversationMessageId":{"type":"string","description":"Unique identifier for the conversation message.","format":"uuid"},"voteType":{"type":"string","enum":["up","down"],"description":"Feedback vote type. Up if feedback is positive"},"question":{"type":"string","description":"Your question.","nullable":true},"answer":{"type":"string","description":"Agent answer.","nullable":true},"createdAt":{"type":"string","description":"Feedback created at"},"updatedAt":{"type":"string","description":"Feedback updated at"},"comment":{"type":"string","description":"Comment for your feedback.","nullable":true}},"required":["id","conversationMessageId","voteType","question","answer","createdAt","updatedAt","comment"]},"ForbiddenErrorDTO":{"type":"object","properties":{"status":{"type":"number","default":403},"name":{"type":"object","default":"FORBIDDEN_ERROR"},"message":{"type":"string","default":"INVALID_CREDENTIALS"},"details":{"type":"array","items":{"type":"object"}}},"required":["status","name","message","details"]},"InternalServerErrorDTO":{"type":"object","properties":{"status":{"type":"number","default":500},"message":{"type":"string","default":"Internal Server Error"}},"required":["status","message"]}}},"paths":{"/external/conversation-message-feedbacks":{"post":{"description":"Create or update existing conversation message feedback. The response includes the conversation message feedback.","operationId":"ExternalApiConversationMessageFeedbacksController_createOrUpdateFeedback","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalApiCrateOrUpdateConversationMessageFeedbackBodyDTO"}}}},"responses":{"201":{"description":"Conversation message feedback successfully created or updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalApiCrateOrUpdateConversationMessageFeedbackResponseDTO"}}}},"403":{"description":"Invalid API key or secret key. Ensure that you are using a valid authentication key.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorDTO"}}}},"500":{"description":"Unexpected error occurred while processing the request. Please try again later.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorDTO"}}}}},"summary":"Create or update conversation message feedback","tags":["Conversation Message Feedbacks","Agent API Key"]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.raiaai.com/api-reference/conversation-message-feedbacks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
